%First normalize images
Data = yna_inormalize(Data, 1);
Data = Data';

%Get the required number of images and their information
ind = find(Per==npb);
index = ind(end);
BootData = Data(1:index, :);  %real image data
BootVar = Var(1:index);       %variation type for each image
BootPer = Per(1:index);       %identity of each image

fprintf('BOOTSTRAP:\n');
%% MANIFOLD LEARNING: Get the best possible reduced coordinate set
[Coord, mCoord, Mapping] = lpp(BootData, BootVar, nvb, nsb);

%% BASIS CALCULATION: Calculate statistics for the basis
[PHI, muPHI, CovPHI, s2] = basis_stats(BootData, mCoord, BootVar, BootPer);

save bootstrap.mat nsb PHI muPHI CovPHI s2 mCoord Mapping

