function [DataBase] = training(X, Coord, muPHI, CovPHI, s2, Per, Var)

iwih = size(X, 2);      %image vector size (image width x image height)

nsb = size(Coord, 2);   %the size of subspace basis (number of vectors in the basis)
ntp = max(Per);         %number of people to be used in training

DataBase = zeros(iwih, (nsb)*ntp);

%For each person
for i = 1 : ntp      
    Cc = Coord(Per==i, :);
    idx = Var(Per==i);
   
    basis = zeros(iwih, nsb);
    %For each pixel location
    for n = 1 : iwih
        mp = muPHI(n, :)';
        Cp = reshape(CovPHI(n, :), nsb, nsb);
        
        S = repmat(s2(n, idx)', 1, nsb);
        A = Cc' * (Cc ./ S) + inv(Cp);
        if sum(Per==i) > 1
            b = sum(Cc .* repmat(X(Per==i, n), 1, nsb) ./ S) + (Cp\mp)';
        else
            b = (Cc .* repmat(X(Per==i, n), 1, nsb) ./ S) + (Cp\mp)';
        end
    
        basis(n, :) = A\b';
    end
    
	%Orthonormalize the resulting columns
    [Q, R] = yna_orthonormal(basis);
    DataBase(:,(i-1)*(nsb)+1:i*(nsb)) = Q;
end