%First normalize images
Data = yna_inormalize(Data, 1);
Data = Data';

%Get the required number of images and their information
ind = find(Per==ntp);
index = ind(end);
ExpData = Data(1:index, :);  %real image data
ExpVar = Var(1:index);       %variation type for each image
ExpPer = Per(1:index);       %identity of each image

%Collect gallery images randomly
tit = randperm(nvt);
tit = tit(1:nti);
index = ismember(ExpVar, tit);
TrData = ExpData(index, :);

%Determine their reduced coordinates in the subspace defined by bootstrap
C = TrData*Mapping;
Dist = EuDist2(C, mCoord);
[sdist plc] = sort(Dist');
plc = plc(1, :); %we use 1nn (get the coordinate of the nearest) 
C = mCoord(plc, :);
TrVar = plc;

%% TRAINING: Recover basis vectors
fprintf('TRAINING:\n');
tic
fprintf( '\tRecover subspace bases                     ');
[DataBase] = training(TrData, C, muPHI, CovPHI, s2, ExpPer(index), TrVar);
fprintf( 'DONE (%0.2f)\n', toc);

%% TESTING: Assign identity to probe images
fprintf('\nTESTING:\n');
index = ~index;
TeData = ExpData(index, :);
Label = ExpPer(index);

tic
fprintf( '\tAssign labels to probes                    ');
Result = testing(DataBase, TeData, ntp, nsb);
fprintf( 'DONE (%0.2f)\n', toc);

%Calculate final recognition performance
Perf = sum(Result == Label) / length(Label) * 100;

fprintf('\nRecognition rate with %d people: %0.2f%%\n', ntp, Perf);