function DIST = GaborDistance(Data, ih, iw)
[ns, d] = size(Data);

%% Gabor Filtering
s = 0.25;
f = 0.85;
p = 1.4;
wV = pi/2;
wH = 0;

GDV = zeros(ns, d);
GDH = zeros(ns, d);
for i = 1 : ns
    [G,IV] = gaborfilter(reshape(Data(i,:),ih,iw),s,f,wV,p);
    [G,IH] = gaborfilter(reshape(Data(i,:),ih,iw),s,f,wH,p);
    
    GDV(i,:) = angle(IV(:));
    GDH(i,:) = angle(IH(:));
end

%% Distance Calculation
DIST = zeros(ns, ns);
for i = 1 : ns-1
    for j = i+1 : ns
        DIST(i,j) = sum(sum(abs(GDV(i,:)-GDV(j,:)) + abs(GDH(i,:)-GDH(j,:))));
    end
end
DIST = DIST + DIST';