function NData = yna_inormalize(Data, type)
%Returns normalized image with mean=0 and std=1
%Data: columns are images
%type: 0 = the sum of resulting image pixel values will be 1
%      1 = resulting image will be zero mean gaussian distribution         
%NData: normalized images

[a, b] = size(Data);

if nargin < 2
    type = 0;
end

NData = zeros(a,b);

if type == 1
    m = mean(Data); %mean and std of each column
    s = std(Data);

    NData = (Data - repmat(m,a,1)) ./ repmat(s,a,1);
elseif type == 0
    for i = 1 : b
        div = norm(Data(:,i));
        NData(:,i) = Data(:,i) / div;
    end
elseif type == 2
    pix = 1: 256;
    s2 = 900;
    p = round((100000/sqrt(2*pi*s2)) * exp(-(pix-128).^2/(2*s2)));
    for i = 1 : b
        NData(:,i) = double(histeq(uint8(Data(:,i)), p));
    end
end