function [Q,R] = yna_orthonormal(A)

[m, n] = size(A);

Q = zeros(m, n);
R = zeros(n, n);

for k = 1:n
    R(k,k) = norm(A(1:m, k));

    if R(k,k) == 0
        break;
    end

    Q(1:m, k) = A(1:m, k) / R(k,k);

    for j = k+1:n
        R(k, j) = dot(Q(1:m, k), A(1:m, j));
        A(1:m, j) = A(1:m, j) - R(k, j) * Q(1:m, k);
    end
end